# -*- coding: utf-8 -*-

#1a) Un grafo diretto è composto da nodi e archi (diretti) tra coppie di nodi. 
# Ciascun nodo è individuato da un'identificatore unico, e ciascun arco anche. 
# A ciascun nodo e a ciascun arco può essere associata una etichetta ("label") 
# con un contenuto informativo. Nel file labelgraph.py è riportata la classe 
# "LDgraph" che permette di rappresentare grafi diretti con etichette.
# Sfruttando il codice in labelgraph.py si scriva una funzione "buildring" che, 
# specificato in input un intero n, restituisca una istanza di LDgraph relativa 
# a un grafo diretto ad anello con n nodi e n archi (ogni arco dal nodo k 
# al (k+1)mod(n-1) ). Gli id dei nodi dovranno essere N0, N1, ecc., e gli id degli 
# archi A0_1, A1_2, ecc. Il contenuto delle label dovrà essere l'id stesso.


import labelgraph as lg 

def buildring(n):
    nodelist=[]
    arclist=[]
    for x in xrange(n):
        nodelist.append(lg.Lnode("N"+str(x), "N"+str(x) ))
    for s,t in ((x,(x+1)%n) for x in xrange(n)):
        arclist.append(lg.LDarc("A"+str(s)+"_"+str(t),nodelist[s],nodelist[t],"A"+str(s)+"_"+str(t)))
    return lg.LDgraph(nodelist,arclist)

