# -*- coding: utf-8 -*-

#4a) Per "composizione a k-meri" di una stringa si intende l'insieme di tutte 
# le sue sottostringhe distinte lunghe k. Nel file labelgraph.py la funzione 
# "kcomp" restituisce la composizione a k-meri di una stringa in input.
# Dato un insieme di stringhe (o "read"), la composizioni a k-meri 
# dell'insieme è l'unione insiemistica delle composizioni dei read.
# Le relazioni tra i k-meri di un insieme di read si possono analizzare usando
# il "grafo euleriano" della composizione, così definito: ogni k-mero 
# genera un arco, con il k-mero come label e diretto da un nodo identificato 
# dai PRIMI k-1 caratteri del k-mero, a un nodo identificato dagli ULTIMI k-1 
# caratteri del k-mero.
# Si scriva una funzione "buildeulerian(k,reads)" che restituisca il grafo 
# euleriano associato all'insieme di stringhe "reads", relativamente al valore 
# intero "k". Sia per i nodi che per gli archi, label e id dovranno avere lo 
# stesso valore.


from labelgraph import *

def buildeulerian(k,reads):
    #first, we compute the k-mer composition
    kmlist=[]
    for s in reads:
        kmlist.extend(kcomp(k,s))
    kmlist=list(set(kmlist))
    #second, we find out the nodes
    lnodes={}
    for ks in kmlist:
        label=ks[:-1]
        if label not in lnodes.keys():
            lnodes[label]=Lnode(label,label)
        label=ks[1:]
        if label not in lnodes.keys():
            lnodes[label]=Lnode(label,label)
    #third, we determine the arcs
    arcs=[]
    for arclabel in kmlist:
        arcs.append(LDarc(arclabel, lnodes[arclabel[:-1]], lnodes[arclabel[1:]], arclabel) )

    return LDgraph(lnodes.values(), arcs)

